#include <pcl/point_types.h>
#include <pcl/io/pcd_io.h>
#include <pcl/visualization/cloud_viewer.h>
#include <pcl/kdtree/kdtree_flann.h>

#include <Eigen/Core>
#include <eigen3/unsupported/Eigen/Splines>

typedef Eigen::Spline<float, 3> Spline3d;

class Spline
{
public:
    std::vector<Eigen::Vector3f> SplineApproximation(std::vector<Eigen::Vector3f> path);

    pcl::PointCloud<pcl::PointXYZ>::Ptr convertSplineToCloud(std::vector<Eigen::Vector3f> &spline);

    pcl::PointCloud<pcl::PointXYZ>::Ptr computeApproximatedBSplines(std::vector<Eigen::Vector3f> &vector_path);

    pcl::PointCloud<pcl::PointXYZ>::Ptr compute(pcl::PointCloud<pcl::PointXYZI>::Ptr &cloud_points);
};
